diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
index b4b0cfb22..ca300f887 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
@@ -9,7 +9,9 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.data.ChunkNibbleArray;
 import net.minecraft.core.world.data.ChunkUnsignedByteArray;
+import net.minecraft.core.world.pos.ChunkSectionTilePos;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.nio.ByteBuffer;
 import java.nio.ShortBuffer;
@@ -20,136 +22,217 @@ import java.util.List;
 public class ChunkSection {
     public static final int SECTION_SIZE_Y = 16;
 
-    public Chunk chunk;
+    public final @NotNull Chunk chunk;
     public int yPosition;
 
-    public short[] blocks;
-    public ChunkUnsignedByteArray data;
-    public ChunkNibbleArray skylightMap;
-    public ChunkNibbleArray blocklightMap;
-    public byte[] biome;
-    public List<Entity> entities;
+    public short @Nullable [] blocks;
+    public @Nullable ChunkUnsignedByteArray data = null;
+    public @Nullable ChunkNibbleArray skylightMap = null;
+    public @Nullable ChunkNibbleArray blocklightMap = null;
+    public byte @NotNull [] biome = new byte[Chunk.CHUNK_SIZE_X * Chunk.CHUNK_SIZE_Z * (SECTION_SIZE_Y >> 3)];
+    public @NotNull List<@NotNull Entity> entities = new ArrayList<>();
 
-    public ChunkSection(Chunk chunk, int yPosition) {
+    public ChunkSection(final @NotNull Chunk chunk, final int yPosition) {
         this.chunk = chunk;
         this.yPosition = yPosition;
-
-        this.entities = new ArrayList<>();
-        this.biome = new byte[Chunk.CHUNK_SIZE_X * Chunk.CHUNK_SIZE_Z * (SECTION_SIZE_Y >> 3)];
     }
 
     public void init() {
         this.data = new ChunkUnsignedByteArray(Chunk.CHUNK_SIZE_X, SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
         this.skylightMap = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
         this.blocklightMap = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
-        Arrays.fill(biome, (byte)-1);
+        Arrays.fill(this.biome, (byte)-1);
+    }
+
+    public static int makeBlockIndex(final @NotNull ChunkSectionTilePos sectionPos) {
+        return (sectionPos.y * Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X) + (sectionPos.z * Chunk.CHUNK_SIZE_X) + sectionPos.x;
+    }
+
+    @Deprecated
+    public static int makeBlockIndex(final int x, final int y, final int z) {
+        return ChunkSection.makeBlockIndex(new ChunkSectionTilePos(x, y, z));
+    }
+
+    public static int makeBiomeIndex(final @NotNull ChunkSectionTilePos sectionPos) {
+        return ((sectionPos.y >> 3) * Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X) + (sectionPos.z * Chunk.CHUNK_SIZE_X) + sectionPos.x;
     }
 
-    public static int makeBlockIndex(int x, int y, int z) {
-        return (y * Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X) + (z * Chunk.CHUNK_SIZE_X) + x;
+    @Deprecated
+    public static int makeBiomeIndex(final int x, final int y, final int z) {
+        return ChunkSection.makeBiomeIndex(new ChunkSectionTilePos(x, y, z));
     }
 
-    public static int makeBiomeIndex(int x, int y, int z) {
-        y >>= 3;
-        return (y * Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X) + (z * Chunk.CHUNK_SIZE_X) + x;
+    public int getBlockId(final @NotNull ChunkSectionTilePos sectionPos) {
+        if (!sectionPos.inBounds() || this.blocks == null) {
+            return 0;
+        }
+
+        return this.blocks[makeBlockIndex(sectionPos)] & 0x3FFF;
     }
 
-    public int getBlock(int x, int y, int z) {
-        if (x < 0 || x >= Chunk.CHUNK_SIZE_X || y < 0 || y >= SECTION_SIZE_Y || z < 0 || z >= Chunk.CHUNK_SIZE_Z) return 0;
-        if (blocks == null) return 0;
-        return blocks[makeBlockIndex(x, y, z)] & 0x3FFF;
+    @Deprecated
+    public int getBlock(final int x, final int y, final int z) {
+        return this.getBlockId(new ChunkSectionTilePos(x, y, z));
     }
 
-    public void setBlock(int x, int y, int z, int id) {
+    public void setBlockId(final @NotNull ChunkSectionTilePos sectionPos, final int id) {
         assert id == 0 || Blocks.getBlock(id) != null;
 
-        if (x < 0 || x >= Chunk.CHUNK_SIZE_X || y < 0 || y >= SECTION_SIZE_Y || z < 0 || z >= Chunk.CHUNK_SIZE_Z) return;
-        if (blocks == null && id == 0) {
+        if (!sectionPos.inBounds() || (this.blocks == null && id == 0)) {
             return;
-        } else if (blocks == null) {
-            blocks = new short[Chunk.CHUNK_SIZE_X * SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z];
+        } else if (this.blocks == null) {
+            this.blocks = new short[Chunk.CHUNK_SIZE_X * SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z];
         }
-        this.blocks[makeBlockIndex(x, y, z)] = (short)(id & 0x3FFF);
+
+        this.blocks[makeBlockIndex(sectionPos)] = (short) (id & 0x3FFF);
     }
 
-    public int getData(int x, int y, int z) {
-        if (x < 0 || x >= Chunk.CHUNK_SIZE_X || y < 0 || y >= SECTION_SIZE_Y || z < 0 || z >= Chunk.CHUNK_SIZE_Z) return 0;
-        if (blocks == null || data == null) {
+    @Deprecated
+    public void setBlock(final int x, final int y, final int z, final int id) {
+        this.setBlockId(new ChunkSectionTilePos(x, y, z), id);
+    }
+
+    public int getData(final @NotNull ChunkSectionTilePos sectionPos) {
+        if (!sectionPos.inBounds() || this.blocks == null || this.data == null) {
             return 0;
         }
-        return this.data.get(x, y, z);
+        return this.data.get(sectionPos.x, sectionPos.y, sectionPos.z);
+    }
+
+    @Deprecated
+    public int getData(final int x, final int y, final int z) {
+        return this.getData(new ChunkSectionTilePos(x, y, z));
     }
 
-    public void setData(int x, int y, int z, int data) {
-        if (x < 0 || x >= Chunk.CHUNK_SIZE_X || y < 0 || y >= SECTION_SIZE_Y || z < 0 || z >= Chunk.CHUNK_SIZE_Z) return;
-        if (blocks == null) {
+    public void setData(final @NotNull ChunkSectionTilePos sectionPos, final int data) {
+        if (!sectionPos.inBounds() || this.blocks == null) {
             return;
-        }
-        if (this.data == null) {
+        } else if (this.data == null) {
             this.data = new ChunkUnsignedByteArray(Chunk.CHUNK_SIZE_X, SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
         }
-        this.data.set(x, y, z, data);
+
+        this.data.set(sectionPos.x, sectionPos.y, sectionPos.z, data);
     }
 
-    public Biome getBiome(int x, int y, int z) {
-        if (x < 0 || x >= Chunk.CHUNK_SIZE_X || y < 0 || y >= SECTION_SIZE_Y || z < 0 || z >= Chunk.CHUNK_SIZE_Z) return null;
-        byte biomeId = biome[makeBiomeIndex(x, y, z)];
-        if (biomeId < 0) return null;
+    @Deprecated
+    public void setData(final int x, final int y, final int z, final int data) {
+        this.setData(new ChunkSectionTilePos(x, y, z), data);
+    }
+
+    public @Nullable Biome getBiome(final @NotNull ChunkSectionTilePos sectionPos) {
+        if (!sectionPos.inBounds()) {
+            return null;
+        }
+
+        final byte biomeId = this.biome[makeBiomeIndex(sectionPos)];
+        if (biomeId < 0) {
+            return null;
+        }
+
         return Registries.BIOMES.getItemByNumericId(biomeId);
     }
 
-    public void setBiome(int x, int y, int z, Biome biome) {
-        if (x < 0 || x >= Chunk.CHUNK_SIZE_X || y < 0 || y >= SECTION_SIZE_Y || z < 0 || z >= Chunk.CHUNK_SIZE_Z) return;
-        int biomeId = Registries.BIOMES.getNumericIdOfItem(biome);
-        this.biome[makeBiomeIndex(x, y, z)] = (byte) biomeId;
+    @Deprecated
+    public @Nullable Biome getBiome(final int x, final int y, final int z) {
+        return this.getBiome(new ChunkSectionTilePos(x, y, z));
+    }
+
+    public void setBiome(final @NotNull ChunkSectionTilePos sectionPos, final @NotNull Biome biome) {
+        if (!sectionPos.inBounds()) {
+            return;
+        }
+
+        final int biomeId = Registries.BIOMES.getNumericIdOfItem(biome);
+        this.biome[makeBiomeIndex(sectionPos)] = (byte) biomeId;
+    }
+
+    @Deprecated
+    public void setBiome(final int x, final int y, final int z, final @NotNull Biome biome) {
+        this.setBiome(new ChunkSectionTilePos(x, y, z), biome);
     }
 
-    public int getBrightness(LightLayer layer, int x, int y, int z) {
-        if (x < 0 || x >= Chunk.CHUNK_SIZE_X || y < 0 || y >= SECTION_SIZE_Y || z < 0 || z >= Chunk.CHUNK_SIZE_Z) return 0;
+    public int getBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkSectionTilePos sectionPos) {
+        if (!sectionPos.inBounds()) {
+            return 0;
+        }
+
+        switch (lightLayer) {
+            case Sky -> {
+                if (this.skylightMap == null) {
+                    return 0;
+                }
+
+                return this.skylightMap.get(sectionPos.x, sectionPos.y, sectionPos.z);
+            }
+            case Block -> {
+                if (this.blocklightMap == null) {
+                    return 0;
+                }
 
-        switch (layer) {
-            case Sky:
-                if (skylightMap == null) return 0;
-                return skylightMap.get(x, y, z);
-            case Block:
-                if (blocklightMap == null) return 0;
-                return blocklightMap.get(x, y, z);
-            default:
+                return this.blocklightMap.get(sectionPos.x, sectionPos.y, sectionPos.z);
+            }
+            default -> {
                 return 0;
+            }
         }
     }
 
-    public void setBrightness(LightLayer layer, int x, int y, int z, int brightness) {
-        if (x < 0 || x >= Chunk.CHUNK_SIZE_X || y < 0 || y >= SECTION_SIZE_Y || z < 0 || z >= Chunk.CHUNK_SIZE_Z) return;
+    @Deprecated
+    public int getBrightness(final @NotNull LightLayer lightLayer, final int x, final int y, final int z) {
+        return this.getBrightness(lightLayer, new ChunkSectionTilePos(x, y, z));
+    }
+
+    public void setBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkSectionTilePos sectionPos, final int brightness) {
+        if (!sectionPos.inBounds()) {
+            return;
+        }
+
+        switch (lightLayer) {
+            case Sky -> {
+                if (this.skylightMap == null) {
+                    this.skylightMap = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
+                }
 
-        switch (layer) {
-            case Sky:
-                if (skylightMap == null) skylightMap = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
-                skylightMap.set(x, y, z, brightness);
-                break;
-            case Block:
-                if (blocklightMap == null) blocklightMap = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
-                blocklightMap.set(x, y, z, brightness);
-                break;
+                this.skylightMap.set(sectionPos.x, sectionPos.y, sectionPos.z, brightness);
+            }
+            case Block -> {
+                if (this.blocklightMap == null) {
+                    this.blocklightMap = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
+                }
+
+                this.blocklightMap.set(sectionPos.x, sectionPos.y, sectionPos.z, brightness);
+            }
         }
     }
 
-    public int getRawBrightness(int x, int y, int z, int skySubtract) {
-        if (x < 0 || x >= Chunk.CHUNK_SIZE_X || y < 0 || y >= SECTION_SIZE_Y || z < 0 || z >= Chunk.CHUNK_SIZE_Z) return 0;
+    @Deprecated
+    public void setBrightness(final @NotNull LightLayer lightLayer, final int x, final int y, final int z, final int brightness) {
+        this.setBrightness(lightLayer, new ChunkSectionTilePos(x, y, z), brightness);
+    }
+
+    public int getRawBrightness(final @NotNull ChunkSectionTilePos sectionPos, final int subtractedSkyLight) {
+        if (!sectionPos.inBounds()) {
+            return 0;
+        }
 
-        return Math.max(getBrightness(LightLayer.Sky, x, y, z) - skySubtract, getBrightness(LightLayer.Block, x, y, z));
+        return Math.max(this.getBrightness(LightLayer.Sky, sectionPos) - subtractedSkyLight, this.getBrightness(LightLayer.Block, sectionPos));
     }
 
-    public void addEntity(Entity entity) {
-        entities.add(entity);
+    @Deprecated
+    public int getRawBrightness(final int x, final int y, final int z, final int subtractedSkyLight) {
+        return this.getRawBrightness(new ChunkSectionTilePos(x, y, z), subtractedSkyLight);
     }
 
-    public void removeEntity(Entity entity) {
-        entities.remove(entity);
+    public void addEntity(final @NotNull Entity entity) {
+        this.entities.add(entity);
     }
 
-    public void getEntitiesWithin(Entity toExclude, AABB aabb, List<Entity> entities) {
-        for (Entity e : this.entities) {
+    public void removeEntity(final @NotNull Entity entity) {
+        this.entities.remove(entity);
+    }
+
+    public void getEntitiesWithin(final @Nullable Entity toExclude, final @NotNull AABB aabb, final @NotNull List<@NotNull Entity> entities) {
+        for (final @NotNull Entity e : this.entities) {
             if (e != toExclude && e.bb.intersects(aabb)) {
                 entities.add(e);
             }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java
index 0edb4b840..d71e185b7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java
@@ -3,6 +3,10 @@ package net.minecraft.core.world.chunk;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.pos.ChunkTilePos;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class DisplayChunk extends EmptyChunk{
     public static int displayBlockId = 0;
@@ -10,59 +14,69 @@ public class DisplayChunk extends EmptyChunk{
     public static int displayBlockPosX = 0;
     public static int displayBlockPosY = 0;
     public static int displayBlockPosZ = 0;
-    public static TileEntity displayTileEntity = null;
-    public DisplayChunk(World world, int x, int z) {
-        super(world, x, z);
+    public static @Nullable TileEntity displayTileEntity = null;
+
+    public DisplayChunk(final @NotNull World world, final @NotNull ChunkPos chunkPos) {
+        super(world, chunkPos);
+    }
+
+    @Deprecated
+    public DisplayChunk(final @NotNull World world, int x, int z) {
+        this(world, new ChunkPos(x, z));
     }
+
     @Override
-    public int getBlockID(int x, int y, int z)
-    {
-        if (x == displayBlockPosX && y == displayBlockPosY && z == displayBlockPosZ){
+    public int getBlockId(final @NotNull ChunkTilePos tilePos) {
+        if (tilePos.x == displayBlockPosX && tilePos.y == displayBlockPosY && tilePos.z == displayBlockPosZ) {
             return displayBlockId;
         }
+
         return 0;
     }
+
     @Override
-    public int getBlockMetadata(int x, int y, int z)
-    {
-        if (x == displayBlockPosX && y == displayBlockPosY && z == displayBlockPosZ){
+    public int getBlockData(final @NotNull ChunkTilePos tilePos) {
+        if (tilePos.x == displayBlockPosX && tilePos.y == displayBlockPosY && tilePos.z == displayBlockPosZ) {
             return displayBlockMeta;
         }
+
         return 0;
     }
+
     @Override
-    public int getBrightness(LightLayer layer, int x, int y, int z)
-    {
+    public int getBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePos tilePos) {
         return 15;
     }
+
     @Override
-    public boolean setTileEntity(int x, int y, int z, TileEntity tileEntity)
-    {
-        if (x == displayBlockPosX && y == displayBlockPosY && z == displayBlockPosZ){
+    public boolean setTileEntity(final @NotNull ChunkTilePos tilePos, final @NotNull TileEntity tileEntity) {
+        if (tilePos.x == displayBlockPosX && tilePos.y == displayBlockPosY && tilePos.z == displayBlockPosZ) {
             displayTileEntity = tileEntity;
-            displayTileEntity.worldObj = world;
-            displayTileEntity.x = x;
-            displayTileEntity.y = y;
-            displayTileEntity.z = z;
+            displayTileEntity.worldObj = this.world;
+            displayTileEntity.x = tilePos.x;
+            displayTileEntity.y = tilePos.y;
+            displayTileEntity.z = tilePos.z;
         }
+
         return true;
     }
 
     @Override
-    public void removeTileEntity(int x, int y, int z)
-    {
-        if (x == displayBlockPosX && y == displayBlockPosY && z == displayBlockPosZ){
+    public void removeTileEntity(final @NotNull ChunkTilePos tilePos) {
+        if (tilePos.x == displayBlockPosX && tilePos.y == displayBlockPosY && tilePos.z == displayBlockPosZ) {
             displayTileEntity = null;
         }
     }
+
     @Override
-    public TileEntity getTileEntity(int x, int y, int z)
-    {
-        if (x == displayBlockPosX && y == displayBlockPosY && z == displayBlockPosZ){
+    public @Nullable TileEntity getTileEntity(final @NotNull ChunkTilePos tilePos) {
+        if (tilePos.x == displayBlockPosX && tilePos.y == displayBlockPosY && tilePos.z == displayBlockPosZ) {
             return displayTileEntity;
         }
+
         return null;
     }
+
     public static void setDisplayTileEntity(World world, TileEntity entity){
         displayTileEntity = entity;
         if (displayTileEntity != null){
@@ -74,17 +88,17 @@ public class DisplayChunk extends EmptyChunk{
     }
 
     @Override
-    public double getBlockHumidity(final int x, final int z) {
+    public double getBlockHumidity(final @NotNull ChunkTilePos tilePos) {
         return 0.5;
     }
 
     @Override
-    public double getBlockTemperature(final int x, final int z) {
+    public double getBlockTemperature(final @NotNull ChunkTilePos tilePos) {
         return 0.5;
     }
 
     @Override
-    public double getBlockVariety(final int x, final int z) {
+    public double getBlockVariety(final @NotNull ChunkTilePos tilePos) {
         return 0.5;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
index c1aa0b772..0d16c9da0 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
@@ -5,203 +5,156 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.pos.ChunkTilePos;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Arrays;
 import java.util.List;
 import java.util.Random;
 
-public class EmptyChunk extends Chunk
-{
+public class EmptyChunk extends Chunk {
+    public EmptyChunk(final @NotNull World world, final @NotNull ChunkPos chunkPos) {
+        super(world, chunkPos);
 
-    public EmptyChunk(World world, int i, int j)
-    {
-        super(world, i, j);
-        // TODO, find out why we have init methods that are never actually used
-        for (ChunkSection section : sections) {
-            if (section != null) {
-                section.init();
-            }
-        }
-        neverSave = true;
+        this.neverSave = true;
     }
 
-    @Override
-    public boolean isAtLocation(int x, int z)
-    {
-        return x == xPosition && z == zPosition;
+    @Deprecated
+    public EmptyChunk(final @NotNull World world, final int x, final int z) {
+        this(world, new ChunkPos(x, z));
     }
 
     @Override
-    public int getHeightValue(int x, int z)
-    {
+    public int getHeightValue(final int x, final int z) {
         return 0;
     }
 
     @Override
-    public void recalcHeightmapOnly()
-    {
-    }
+    public void recalcHeightmapOnly() { }
 
     @Override
-    public void recalcHeightmap()
-    {
-    }
+    public void recalcHeightmap() { }
 
     @Override
-	public int getBlockID(int x, int y, int z)
-    {
+    public int getBlockId(final @NotNull ChunkTilePos tilePos) {
         return 0;
     }
 
     @Override
-	public boolean setBlockIDWithMetadata(int x, int y, int z, int id, int data)
-    {
+    public boolean setBlockIdData(final @NotNull ChunkTilePos tilePos, final int id, final int data) {
         return true;
     }
 
     @Override
-	public boolean setBlockID(int x, int y, int z, int id)
-    {
+    public boolean setBlockId(final @NotNull ChunkTilePos tilePos, final int id) {
         return true;
     }
 
     @Override
-	public int getBlockMetadata(int x, int y, int z)
-    {
+    public int getBlockData(final @NotNull ChunkTilePos tilePos) {
         return 0;
     }
 
     @Override
-	public void setBlockMetadata(int x, int y, int z, int value)
-    {
+    public boolean setBlockData(final @NotNull ChunkTilePos tilePos, final int value) {
+        return true;
     }
 
     @Override
-	public int getBrightness(LightLayer layer, int x, int y, int z)
-    {
+    public int getBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePos tilePos) {
         return 0;
     }
 
     @Override
-	public void setBrightness(LightLayer layer, int x, int y, int z, int value)
-    {
-    }
+    public void setBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePos tilePos, final int value) { }
 
     @Override
-	public int getRawBrightness(int x, int y, int z, int skySubtract)
-    {
+    public int getRawBrightness(final @NotNull ChunkTilePos tilePos, final int subtractedSkyLight) {
         return 0;
     }
 
     @Override
-	public void addEntity(Entity entity)
-    {
-    }
+    public void addEntity(final @NotNull Entity entity) { }
 
     @Override
-	public void removeEntity(Entity entity)
-    {
-    }
+    public void removeEntity(final @NotNull Entity entity) { }
 
     @Override
-	public void removeEntityAtIndex(Entity entity, int index)
-    {
-    }
+    public void removeEntityAtIndex(final @NotNull Entity entity, final int index) { }
 
     @Override
-	public boolean canBlockSeeTheSky(int x, int y, int z)
-    {
+    public boolean canBlockSeeSky(final @NotNull ChunkTilePos tilePos) {
         return false;
     }
 
     @Override
-	public TileEntity getTileEntity(int x, int y, int z)
-    {
+    public @Nullable TileEntity getTileEntity(final @NotNull ChunkTilePos tilePos) {
         return null;
     }
 
     @Override
-	public void addTileEntity(TileEntity tileEntity)
-    {
-    }
+    public void addTileEntity(final @NotNull TileEntity tileEntity) { }
 
     @Override
-	public boolean setTileEntity(int x, int y, int z, TileEntity tileEntity)
-    {
+    public boolean setTileEntity(final @NotNull ChunkTilePos tilePos, final @NotNull TileEntity tileEntity) {
         return false;
     }
 
     @Override
-	public void removeTileEntity(int x, int y, int z)
-    {
-    }
+    public void removeTileEntity(final @NotNull ChunkTilePos tilePos) { }
 
     @Override
-	public void onLoad()
-    {
-    }
+    public void onLoad() { }
 
     @Override
-	public void onUnload()
-    {
-    }
+    public void onUnload() { }
 
     @Override
-	public void setChunkModified()
-    {
-    }
+    public void setChunkModified() { }
 
     @Override
-	public void getEntitiesWithin(Entity toExclude, AABB aabb, List<Entity> entities)
-    {
-    }
+    public void getEntitiesWithin(final Entity toExclude, final AABB aabb, final List<Entity> entities) { }
 
     @Override
-    public <T extends Entity> void getEntitiesWithin(Class<T> ofClass, AABB aabb, List<@NotNull T> entities) {
-
-    }
+    public <T extends Entity> void getEntitiesWithin(final Class<T> ofClass, final AABB aabb, final List<@NotNull T> entities) { }
 
     @Override
-	public boolean needsSaving(boolean saveImmediately)
-    {
+    public boolean needsSaving(final boolean saveImmediately) {
         return false;
     }
 
     @Override
-	public int setChunkData(byte data[], int minX, int minY, int minZ, int maxX, int maxY, int maxZ,
-                            int startIndex)
-    {
-        int dx = maxX - minX;
-        int dy = maxY - minY;
-        int dz = maxZ - minZ;
-        int chunkSizeBlocks = dx * dy * dz;
+    public int setChunkData(final byte[] data, final int minX, final int minY, final int minZ, final int maxX, final int maxY, final int maxZ,
+                            final int startIndex) {
+        final int dx = maxX - minX;
+        final int dy = maxY - minY;
+        final int dz = maxZ - minZ;
+        final int chunkSizeBlocks = dx * dy * dz;
         return (chunkSizeBlocks * 2) + chunkSizeBlocks + (chunkSizeBlocks / 2) * 2;
     }
-    
-    @Override
-	public int getChunkData(byte data[], int minX, int minY, int minZ, int maxX, int maxY, int maxZ,
-                            int startIndex)
-    {
-        int dx = maxX - minX;
-        int dy = maxY - minY;
-        int dz = maxZ - minZ;
-        int chunkSizeBlocks = dx * dy * dz;
-        int dataSize = (chunkSizeBlocks * 2) + chunkSizeBlocks + (chunkSizeBlocks / 2) * 2;
-        Arrays.fill(data, startIndex, startIndex + dataSize, (byte)0);
+
+    @Override
+    public int getChunkData(final byte[] data, final int minX, final int minY, final int minZ, final int maxX, final int maxY, final int maxZ,
+                            final int startIndex) {
+        final int dx = maxX - minX;
+        final int dy = maxY - minY;
+        final int dz = maxZ - minZ;
+        final int chunkSizeBlocks = dx * dy * dz;
+        final int dataSize = (chunkSizeBlocks * 2) + chunkSizeBlocks + (chunkSizeBlocks / 2) * 2;
+        Arrays.fill(data, startIndex, startIndex + dataSize, (byte) 0);
         return dataSize;
     }
 
 
     @Override
-	public Random getChunkRandom(long xor)
-    {
-        return new Random(world.getRandomSeed() + (long)(xPosition * xPosition * 0x4c1906) + (long)(xPosition * 0x5ac0db) + (long)(zPosition * zPosition) * 0x4307a7L + (long)(zPosition * 0x5f24f) ^ xor);
+    public @NotNull Random getChunkRandom(final long xor) {
+        return new Random(this.world.getRandomSeed() + ((long) this.pos.x * this.pos.x * 0x4c1906) + (this.pos.x * 0x5ac0dbL) + (long) this.pos.z * this.pos.z * 0x4307a7L + (this.pos.z * 0x5f24fL) ^ xor);
     }
 
     @Override
-	public boolean isChunkEmpty()
-    {
+    public boolean isChunkEmpty() {
         return true;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/data/ChunkNibbleArray.java b/game/core/src/main/java/net/minecraft/core/world/data/ChunkNibbleArray.java
index 616f2e242..3bf581205 100644
--- a/game/core/src/main/java/net/minecraft/core/world/data/ChunkNibbleArray.java
+++ b/game/core/src/main/java/net/minecraft/core/world/data/ChunkNibbleArray.java
@@ -1,5 +1,7 @@
 package net.minecraft.core.world.data;
 
+import org.jetbrains.annotations.NotNull;
+
 /**
  * Models an array of nibbles that is accessible by X, Y and Z coordinates.
  */
@@ -34,7 +36,7 @@ public class ChunkNibbleArray
     }
 
     @Override
-    public Integer get(int x, int y, int z)
+    public @NotNull Integer get(int x, int y, int z)
     {
         int index = (y * zSize * xSize) + (z * xSize) + x;
         int nibbleIndex = index >> 1;
diff --git a/game/core/src/main/java/net/minecraft/core/world/data/ChunkUnsignedByteArray.java b/game/core/src/main/java/net/minecraft/core/world/data/ChunkUnsignedByteArray.java
index 91540d6ec..093a0b00c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/data/ChunkUnsignedByteArray.java
+++ b/game/core/src/main/java/net/minecraft/core/world/data/ChunkUnsignedByteArray.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.world.data;
 
 
+import org.jetbrains.annotations.NotNull;
+
 /**
  * Models an array of unsigned bytes that is accessible by X, Y and Z coordinates.
  */
@@ -35,7 +37,7 @@ public class ChunkUnsignedByteArray
     }
 
     @Override
-    public Integer get(int x, int y, int z)
+    public @NotNull Integer get(int x, int y, int z)
     {
         int index = (y * zSize * xSize) + (z * xSize) + x;
         return Byte.toUnsignedInt(data[index]);
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkFeatureDecorator.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkFeatureDecorator.java
index 5f39eaa7d..ccbdcc2df 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkFeatureDecorator.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkFeatureDecorator.java
@@ -44,8 +44,8 @@ public abstract class ChunkFeatureDecorator
         this.world.scheduledUpdatesAreImmediate = true;
         BlockLogicSand.fallInstantly = true;
 
-        final int chunkX = chunk.xPosition;
-        final int chunkZ = chunk.zPosition;
+        final int chunkX = chunk.pos.x;
+        final int chunkZ = chunk.pos.z;
         final int worldX = chunkX * 16;
         final int worldZ = chunkZ * 16;
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
index 9e640a581..45986e208 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
@@ -47,8 +47,8 @@ public class ChunkGeneratorClassic
     {
         ChunkGeneratorResult result = new ChunkGeneratorResult();
 
-        int chunkX = chunk.xPosition;
-        int chunkZ = chunk.zPosition;
+        int chunkX = chunk.pos.x;
+        int chunkZ = chunk.pos.z;
 
         final float mod = 1.3F;
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/debug/ChunkDecoratorDebug.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/debug/ChunkDecoratorDebug.java
index 131e1dc52..a052ce914 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/debug/ChunkDecoratorDebug.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/debug/ChunkDecoratorDebug.java
@@ -10,8 +10,8 @@ public class ChunkDecoratorDebug
     @Override
     public void decorate(Chunk chunk)
     {
-        int chunkX = chunk.xPosition;
-        int chunkZ = chunk.zPosition;
+        int chunkX = chunk.pos.x;
+        int chunkZ = chunk.pos.z;
 
         int chunkBlockOffset = chunkX * (Chunk.CHUNK_SIZE_X / 2);
         int chunkMetaOffset = chunkZ * (Chunk.CHUNK_SIZE_Z / 2);
